<template>
  <el-dialog
    :title="title"
    :visible.sync="open"
    width="70%"
    append-to-body
    :close-on-click-modal="false"
    @close="cancel"
  >
    <div class="form-dialog-box"
    v-loading="loading"
    :element-loading-text="loadingText"
    element-loading-spinner="el-icon-loading"
    element-loading-background="rgba(0, 0, 0, 0.8)">
      <el-form :model="form" ref="form" :rules="rules" label-width="130px">
        <el-form-item label="上传手绘地图" prop="imgUrl">
          <div
          style="width: 120px;"
          v-loading="actionUrlLoading"
          element-loading-text="上传中..."
          element-loading-spinner="el-icon-loading"
          element-loading-background="rgba(0, 0, 0, 0.8)"
          >
            <el-upload
              class="avatar-uploader"
              :action="actionUrl"
              :data="{
                bucket: 'tourism'
              }"
              :show-file-list="false"
              accept=".jpg, .png, jpeg"
              :on-success="handleAvatarSuccess"
              :on-progress="handleAvatarProgress"
              :before-upload="beforeAvatarUpload"
              :disabled="actionUrlLoading"
              :on-error="handleAvatarError"
              >
              <img v-if="form.imgUrl" style="width: 300px;height: 300px;" :src="form.imgUrl" class="avatar">
              <i v-else class="el-icon-plus avatar-uploader-icon"></i>
            </el-upload>
          </div>
          <span>支持扩展名：jpg、png,大小限定≤3MB图片</span>
        </el-form-item>
        <el-form-item label="定位">
          <el-form-item label="左下角" label-width="100px">
            <div style="display: flex;">
              <el-form-item label="经度" label-width="80px" prop="leftLongitude">
                <el-input style="width: 350px;" v-model="form.leftLongitude" placeholder="请输入左下角经度" />
              </el-form-item>
              <el-form-item label="纬度" prop="leftLatitude">
                <el-input style="width: 350px;" v-model="form.leftLatitude" placeholder="请输入左下角纬度" />
              </el-form-item>
            </div>
          </el-form-item>
          
          <el-form-item label="右下角" style="margin-top: 20px;" label-width="100px">
            <div style="display: flex;">
              <el-form-item label="经度" label-width="80px" prop="rightLongitude">
                <el-input style="width: 350px;" v-model="form.rightLongitude" placeholder="请输入右下角经度" />
              </el-form-item>
              <el-form-item label="纬度" prop="rightLatitude">
                <el-input style="width: 350px;" v-model="form.rightLatitude" placeholder="请输入右下角纬度" />
              </el-form-item>
            </div>
          </el-form-item>
        </el-form-item>
        <el-form-item label="可见级别" >
          <div style="display: flex;">
            <el-form-item label="最小" prop="minNum">
              <el-input style="width: 350px;" v-model="form.minNum" placeholder="请输入最小可见级别" />
            </el-form-item>
            <el-form-item label="最大" prop="maxNum">
              <el-input style="width: 350px;" v-model="form.maxNum" placeholder="请输入最大可见级别" />
            </el-form-item>
          </div>
          <span>(控制小程序景点导览中手绘地图在哪一级别显示，显示区间10-20调节)</span>
        </el-form-item>
        
      </el-form>
    </div>
    <span slot="footer" class="dialog-footer" v-if="formStatus==1">
      <el-button @click="cancel">取消</el-button>
      <el-button
        type="primary"
        @click="submitForm"
        :loading="loading"
        element-loading-text="提交中..."
        element-loading-spinner="el-icon-loading"
        element-loading-background="rgba(0, 0, 0, 0.8)"
      > 
        {{ loading ? '提交中...' : '保存' }}
      </el-button>
    </span>
    <!-- 添加或修改对话框 End -->
  </el-dialog>
</template>

<script>
import { 
  getTableDeatilsByIdApi,
  updateTableApi,
  addTableApi
 } from '@/api/CURD'
import { quillEditor } from 'vue-quill-editor'
 
import 'quill/dist/quill.core.css'
import 'quill/dist/quill.snow.css'
import 'quill/dist/quill.bubble.css'

export default {
  name: "addAndEdit",
  dicts: ['tourism_online_status','tourism_online_type'],
  components: {quillEditor},
  data() {
    return {
      title: "",
      model: "", // EDIT: 编辑模式 ADD : 新增模式  EDITInit : 编辑模式（需要请求详情）
      open: false,
      loading: false,
      loadingText: "拼命加载数据中...",
      formStatus: null, // 0/null : 加载中 1 : 获取详情成功 2  : 获取详情失败 
      configUrl: {
        add: '/merchant/merchantMap/save', // 新增地址
        details: '/merchant/merchantMap/info', // 详情地址
        edit: '/merchant/merchantMap/save', // 编辑地址
      },
      form: {
        id: undefined,
      },
      rules: {
        imgUrl: [{ required: true, message: "请上传图片", trigger: ["change","blur"] }],
        leftLongitude: [{ required: true, message: "请输入左下角经度", trigger: ["change","blur"] }],
        leftLatitude: [{ required: true, message: "请输入左下角纬度", trigger: ["change","blur"] }],
        rightLongitude: [{ required: true, message: "请输入右下角经度", trigger: ["change","blur"] }],
        rightLatitude: [{ required: true, message: "请输入右下角纬度", trigger: ["change","blur"] }],
        minNum: [{ required: true, message: "请输入最小可见级别", trigger: ["change","blur"] }],
        maxNum: [{ required: true, message: "请输入最大可见级别", trigger: ["change","blur"] }],
      },
      //  上传文件
      actionUrl: process.env.VUE_APP_BASE_API + process.env.VUE_APP_UPLOAD_IMAGE,
      actionUrlLoading: false,
    };
  },
  methods: {
    async initData(title , model,row){
      this.title = title
      this.open = true
      this.loadingText = "拼命加载数据中..."
      this.loading = true
      this.actionUrlLoading = false
      this.model = model
      this.formStatus = 0
      if(model=='ADD') { // 新增
        this.$set(this,'form',row)
        this.formStatus = 1
      }else if(model=='EDIT') { // 新增
        let obj = {
          ...row
        }
        this.$set(this,'form',obj)
        this.formStatus = 1
      }else if(model=='EDITInit') { // 新增
        await this.getTableDeatilsFun(row)
      }
      this.loading = false
      this.$nextTick(()=>{
        if(this.$refs["form"]) {
          this.$refs["form"].clearValidate();
        }
      })
    },
    /** 获取详情 */
    async getTableDeatilsFun(row) {
      const id = row.id
      this.loading = true
      try {
        let res = await getTableDeatilsByIdApi(this.configUrl.details,{id})
        if(res.code == 200) {
          let obj = {
          ...res.data
        }
          this.$set(this,'form',JSON.parse(JSON.stringify(obj)))
          this.formStatus = 1
        }else {
          this.$message.error('获取详情失败!!!');
          this.formStatus = 2
          this.loading = false
          this.open = false;
        }
        this.loading = false
      } catch (error) {
        console.error('获取详情失败!!!!',error)
        this.formStatus = 2
        this.loading = false
        this.open = false;
      }
    },
    /**
     * 保存
     * @date 2023-11-22
     * @returns {any}
     */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.loadingText = "提交数据中..."
          this.loading = true
          if (this.model != 'ADD') {
            addTableApi(
              this.configUrl.edit,{
                ...this.form
              }).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.loading = false
              this.open = false;
              this.$emit('refresh')
            }).catch(()=>{
              this.$message.error("修改失败!!!");
              this.loading = false
            })
          } else {
            addTableApi(this.configUrl.edit,{
                ...this.form
              }).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.loading = false
              this.open = false;
              this.$emit('refresh')
            }).catch(()=>{
              this.$message.error("新增失败!!!");
              this.loading = false
            })
          }
        }
      });
    },
    /**
     * 重置
     * @date 2023-11-22
     * @returns {any}
     */
    reset() {
      if(this.$refs["form"]) {
        this.$refs["form"].clearValidate();
      }
    },
    /**
     * 关闭弹框
     * @date 2023-11-22
     * @returns {any}
     */
    cancel() {
      this.reset();
      this.open = false;
    },
    /**  上传图片  */
    handleAvatarSuccess(res, file) {
      console.log("res, file",res, file)
      this.actionUrlLoading = false
      if(res.code != 200) {
        this.$set(this.form,'imgUrl',null) 
      }else {
        this.$set(this.form,'imgUrl',res.data.url) 
      }
      
    },
    beforeAvatarUpload(file) {
      const isLt2M = file.size / 1024 / 1024 <= 3;
      let testmsg = file.name.substring(file.name.lastIndexOf('.')+1)
      let typeList = ['png','jepg','jpg']
      const isJPG = typeList.includes(testmsg);
      if (!isJPG) {
        this.$message.error(`上传头像图片只能是 ${typeList} 格式!`);
      }
      if (!isLt2M) {
        this.$message.error('上传头像图片大小不能超过 2MB!');
      }
      return isJPG && isLt2M;
    },
    handleAvatarProgress(){
      this.actionUrlLoading = true
    },
    handleAvatarError() {
      this.actionUrlLoading = false
    }
  },
};
</script>

<style lang="scss" scoped>
.form-dialog-box {
  padding: 0 30px;
  padding: 0 30px;
  min-height: 50vh;
  max-height: 65vh;
  overflow-y: auto;
  .form-title {
    padding: 0 0 10px 0;
    span {
      display: flex;
      color: rgba(65,80,88,1);
      font-size: 16px;
      font-family: SourceHanSansSC;
      font-weight: 700;
      line-height: 23px;
      border-left: 4px solid rgb(22, 132, 252);
      padding-left: 10px;
    }
    
  }
  ::v-deep .ql-editor {
    height: 400px;
  }
  .upload-btn {
    width: 100px;
    height: 100px;
    background-color: #fbfdff;
    border: dashed 1px #c0ccda;
    border-radius: 5px;
    i {
      font-size: 30px;
      margin-top: 20px;
    }
    &-text {
      margin-top: -10px;
    }
  }
  .avatar {
    cursor: pointer;
  }
}
.el-table{
  .upload-btn {
    width: 100px;
    height: 100px;
    background-color: #fbfdff;
    border: dashed 1px #c0ccda;
    border-radius: 5px;
    i {
      font-size: 30px;
      margin-top: 20px;
    }
    &-text {
      margin-top: -10px;
    }
  }
  .avatar {
    cursor: pointer;
  }
}

.area-container {
  min-height: 400px;
}

::v-deep .area-wrap-city.el-cascader {
  line-height: normal;
  .el-input {
    cursor: pointer;
    width: 100% !important;
    height: 28px !important;
    .el-input__inner {
      display: none !important;
    }
    span.el-input__suffix {
      position: inherit !important;
      i.el-input__icon {
        line-height: inherit;
        margin-left: 5px;
      }
    }

    .el-input__wrapper {
      box-shadow: none;
      input {
        display: none;
      }
    }
  }

  .el-cascader__tags {
    display: none;
  }
}

.area-city-popper {
  .el-cascader-panel {
    .el-scrollbar.el-cascader-menu {
      .el-cascader-menu__wrap.el-scrollbar__wrap {
        height: 315px;
      }
    }
  }
}

::v-deep .avatar-uploader .el-upload {
    border: 1px dashed #d9d9d9;
    border-radius: 6px;
    cursor: pointer;
    position: relative;
    overflow: hidden;
  }
  ::v-deep .avatar-uploader .el-upload:hover {
    border-color: #409EFF;
  }
  ::v-deep .avatar-uploader-icon {
    font-size: 28px;
    color: #8c939d;
    width: 100px;
    height: 100px;
    line-height: 100px;
    text-align: center;
  }
  ::v-deep .avatar {
    width: 300px;
    height: 300px;
    display: block;
  }
</style>
<style>
.custom-class-box {
  z-index: 999999 !important;
}
</style>